<?php


include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/payanyway.php');

$payanyway = new payanyway();

$errors = array();

/* Check for mandatory fields */
$requiredFields = array(
	'MNT_ID', 
	'MNT_TRANSACTION_ID', 
	'MNT_TEST_MODE', 
	'MNT_AMOUNT', 
	'MNT_CURRENCY_CODE', 
	'MNT_SIGNATURE', 
	'MNT_SUCCESS_URL', 
	'MNT_FAIL_URL', 
	'followup', 
	'javascriptEnabled', 
	'payment_system',
	'paymentSystem_unitId'
);

switch ($_POST['payment_system'])
{
	case 'post':
		$requiredFields = array_merge($requiredFields, array(
			'additionalParameters_mailofrussiaSenderIndex',
			'additionalParameters_mailofrussiaSenderRegion',
			'additionalParameters_mailofrussiaSenderAddress',
			'additionalParameters_mailofrussiaSenderName'
		));
		break;
	case 'moneymail':
		$requiredFields = array_merge($requiredFields, array(
			'additionalParameters_buyerEmail'
		));
		break;
	case 'dengimail':
		$requiredFields = array_merge($requiredFields, array(
			'additionalParameters_qiwiUser'
		));
		break;
	case 'qiwi':
		$requiredFields = array_merge($requiredFields, array(
			'additionalParameters_dmrBuyerEmail'
		));
		break;
	case 'alfaclick':
		$requiredFields = array_merge($requiredFields, array(
			'additionalParameters_alfaIdClient'
		));
		break;
	case 'euroset':
		$requiredFields = array_merge($requiredFields, array(
			'additionalParameters_rapidaPhone'
		));
		break;
}

foreach ($requiredFields AS $field)
	if (!isset($_POST[$field]))
		$errors[] = 'Missing field '.$field;

$message = '';
foreach ($_POST AS $key => $value)
	$message .= $key.': '.$value."\n";

if (sizeof($errors))
{
	$message .= sizeof($errors).' error(s):'."\n";
	
	/* Force status to 1 - ERROR ! */
	$_POST['status'] = 1;
}
foreach ($errors AS $error)
	$message .= $error."\n";
$message = nl2br(strip_tags($message));

$id_cart = (int)(substr($_POST['MNT_TRANSACTION_ID'], 0, strpos($_POST['MNT_TRANSACTION_ID'], '_')));
$secure_cart = explode('_', $_POST['MNT_TRANSACTION_ID']);
$status = (int)($_POST['status']);
$cart = new Cart((int)($secure_cart[0]));
$customer = new Customer((int)$cart->id_customer);

switch ($status)
{	
	case 0:
		$payanyway->validateOrder((int)($secure_cart[0]), Configuration::get('PS_OS_BANKWIRE'), (float)($_POST['MNT_AMOUNT']), $payanyway->displayName, $message, array(), NULL, false, $customer->secure_key);
		break;

	/* Unknown or error */
	default:
		$payanyway->validateOrder((int)($secure_cart[0]), Configuration::get('PS_OS_ERROR'), 0, $payanyway->displayName, $message, array(), NULL, false, $customer->secure_key);
		break;
}

$params = array();
foreach ($requiredFields as $field)
{
	$key = str_replace(
			array('paymentSystem_', 'additionalParameters_'), 
			array('paymentSystem.', 'additionalParameters.'),
			$field);
	$params[] = $key."=".urlencode($_POST[$field]);
}

if ($_POST['isInvoice'] == '1')
{
	$url = $_POST['invoiceUrl'];
}
else
{
	$url = "https://".Configuration::get('PAYANYWAY_PAYMENT_URL')."/assistant.htm?";
}

Tools::redirect($url. implode("&", $params), '');